<?php
namespace SM\Service;

use SM\Factory\MapaFaturamentoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\FindService;

class MapaFaturamentoService
{

    protected $MapaFaturamentoFactory;
    protected $Environment;
    protected $newCode;
    protected $FindService;

    public function __construct(MapaFaturamentoFactory $MapaFaturamentoFactory, Environment $Environment, NewCode $newCode, FindService $FindService)
    {
        $this->MapaFaturamentoFactory       = $MapaFaturamentoFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->FindService                  = $FindService;
    }

    public function getMapaFaturamento()
    {
           return $this->MapaFaturamentoFactory->getMapaFaturamento();
    }

    public function getMapaFaturamentoParc($parametros)
    {
        return $this->MapaFaturamentoFactory->getMapaFaturamentoParc(array(
            "CDSERVORCA" => $parametros['CDSERVORCA']
        ));
    }

    public function getMapaFaturamentoCli($parametros)
    {
        return $this->MapaFaturamentoFactory->getMapaFaturamentoCli(array(
            "CDSERVORCA"    => $parametros['CDSERVORCA'],
            "NRPARCNEGOCIO"  => $parametros['NRPARCNEGOCIO']
        ));
    }

    public function getDadosFaturamentoCompleto()
    {
           return $this->MapaFaturamentoFactory->getDadosFaturamentoCompleto();
    }
}
