/*-- ================================================================== --
-- SISTEMA         : PONTO DE VENDA                                   --
-- DATA DA CRIAO : INCIO - 05/07/2002                              --
-- CRIAO         : Renata Diniz                                     --
-- OBJETIVOS       : Atualiza os saldos dos consumidores              --
-- ================================================================== --
*/
/*************************ATENO*****************************/
/*
SE ESTA PROCEDURE FOR ALTERADA  NECESSRIA A CPIA DA MESMA PARA O COMPONENTE
ADOCommand DE NOME 'acmAtualizaSaldCons' NA TELA DBGERALFOS PARA MANTER O BANCO
DE DADOS LOCAL (MSDE) SEMPRE ATUALIZADO.

SISTEMA FOS - EQUIPE FORSALE - ANDR PERROUT CERQUEIRA 30-11-2007
*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'ATUALIZA_SALDO_CONS' AND
	        TYPE = 'P'                    AND
	        U.UID = O.UID                 AND
	        U.NAME = USER)

   DROP PROCEDURE ATUALIZA_SALDO_CONS
   GO

CREATE PROCEDURE ATUALIZA_SALDO_CONS
  @P_CDFILIAL     VARCHAR(4),
  @P_CDCLIENTE    VARCHAR(21),
  @P_CDCONSUMIDOR VARCHAR(21),
  @P_DATA         DATETIME,
  @P_OPERADOR     VARCHAR(12)

 AS

  DECLARE @V_CDCLIENTE     VARCHAR(21);
  DECLARE @V_CDCONSUMIDOR  VARCHAR(21);
  DECLARE @V_MENORIGUAL    FLOAT;
  DECLARE @V_MAIORIGUAL    FLOAT;
  DECLARE @V_REGMENORIGUAL FLOAT;
  DECLARE @V_DTLANCAMENTO  DATETIME;
  DECLARE @V_UCONSUMIDOR   VARCHAR(1);
  DECLARE @V_DTMOVCLI      DATETIME;
  DECLARE @V_VRMOVCLI      FLOAT;
  DECLARE @V_VRMOVPESCONS  FLOAT;
  DECLARE @V_IDTIPMOCVLI   VARCHAR(1);
  DECLARE @V_VRSALDOCONS   FLOAT;
  DECLARE @V_VRSALDPECONS  FLOAT;
  DECLARE @V_VRATUALIZACAO FLOAT;
  DECLARE @V_VRATUALPECONS FLOAT;

  DECLARE @C_DTMOVCLI     DATETIME;
  DECLARE @C_VRMOVCLI     FLOAT;
  DECLARE @C_VRMOVPESCONS FLOAT;
  DECLARE @C_IDTIPMOCVLI  VARCHAR(1);
  DECLARE @C_VRSALDOCONS  FLOAT;
  DECLARE @C_VRSALDPECONS FLOAT;

BEGIN

   IF (@P_CDCONSUMIDOR IS NULL) BEGIN
      SET @V_UCONSUMIDOR = 'U';
   END ELSE BEGIN
      SET @V_UCONSUMIDOR = 'X';
   END;

   /*Retorna a primeira data/hora a partir da data/hora informada (maior ou igual)*/
   SELECT
      @V_DTLANCAMENTO = MIN(DTMOVCLI)
   FROM
      MOVICLIE
   WHERE
      (CDCLIENTE       = @P_CDCLIENTE   ) AND
      ((CDCONSUMIDOR   = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
       (@V_UCONSUMIDOR  = 'U'))) AND
      (DTMOVCLI       >= @P_DATA        );

   /*Retorna o nmero de registros menores ou iguais  data/hora informada*/
   SELECT
      @V_REGMENORIGUAL = COUNT(DTMOVCLI)
   FROM
      MOVICLIE
   WHERE
      (CDCLIENTE      = @P_CDCLIENTE      ) AND
      ((CDCONSUMIDOR  = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
       (@V_UCONSUMIDOR = 'U'))) AND
      (DTMOVCLI      <= @V_DTLANCAMENTO   );

   /*Se a data/hora informada for a primeira o saldo ser atualizado com o valor do prprio lanamento*/
   IF @V_REGMENORIGUAL = 1 BEGIN

      /*Seleciona o lanamento*/
      SELECT
         @V_DTMOVCLI  = DTMOVCLI, @V_VRMOVCLI = VRMOVCLI,
         @V_VRMOVPESCONS = VRMOVPESCONS,  @V_IDTIPMOCVLI = IDTIPMOCVLI,
         @V_VRSALDOCONS = VRSALDOCONS, @V_VRSALDPECONS = VRSALDPECONS
      FROM
         MOVICLIE
      WHERE
         (CDCLIENTE      = @P_CDCLIENTE      ) AND
         ((CDCONSUMIDOR  = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
          (@V_UCONSUMIDOR = 'U'))) AND
         (DTMOVCLI       = @V_DTLANCAMENTO   )
      ORDER BY
         DTMOVCLI;

      IF @V_IDTIPMOCVLI = 'D' BEGIN
         SET @V_VRMOVCLI      = (-1) * @V_VRMOVCLI;
         SET @V_VRMOVPESCONS  = (-1) * @V_VRMOVPESCONS;
      END ELSE IF @V_IDTIPMOCVLI = 'A' BEGIN
         SET @V_VRMOVCLI      = 0;
         SET @V_VRMOVPESCONS  = 0;
      END ELSE IF @V_IDTIPMOCVLI = 'X' BEGIN
         SET @V_VRMOVCLI      = 0;
         SET @V_VRMOVPESCONS  = 0;
      END;

      /*Grava no valor do saldo, o valor da movimentao, visto que no h lanamento anterior*/
      UPDATE
         MOVICLIE
      SET
         VRSALDOCONS  = @V_VRMOVCLI,
         VRSALDPECONS = @V_VRMOVPESCONS,
         CDOPERECSALD = @P_OPERADOR,
         DTRECMOVCLIE = GETDATE()
      WHERE
         (CDCLIENTE      = @P_CDCLIENTE      ) AND
         ((CDCONSUMIDOR  = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND (@V_UCONSUMIDOR = 'U'))) AND
         (DTMOVCLI       = @V_DTLANCAMENTO   );

      /*Retorna o nmero de registros maiores ou iguais  data/hora informada*/
      SELECT
         @V_MAIORIGUAL = COUNT(DTMOVCLI)
      FROM
         MOVICLIE
      WHERE
         (CDCLIENTE     = @P_CDCLIENTE      ) AND
         ((CDCONSUMIDOR = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
          (@V_UCONSUMIDOR = 'U'))) AND
         (DTMOVCLI     >= @V_DTLANCAMENTO   );
      /*Atualiza lanamentos posteriores*/
      IF @V_MAIORIGUAL > 1 BEGIN
         DECLARE CUR_MOVICLIE CURSOR FOR
            SELECT
               DTMOVCLI,VRMOVCLI,VRMOVPESCONS,IDTIPMOCVLI,VRSALDOCONS,VRSALDPECONS
            FROM
               MOVICLIE
            WHERE
               (CDCLIENTE     = @P_CDCLIENTE      ) AND
               ((CDCONSUMIDOR = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
                (@V_UCONSUMIDOR = 'U'))) AND
               (DTMOVCLI     >= @V_DTMOVCLI   )
            ORDER BY
               DTMOVCLI
         OPEN CUR_MOVICLIE;
         FETCH NEXT FROM CUR_MOVICLIE INTO @C_DTMOVCLI,@C_VRMOVCLI,@C_VRMOVPESCONS,@C_IDTIPMOCVLI,@C_VRSALDOCONS,@C_VRSALDPECONS;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_VRMOVCLI     = @C_VRMOVCLI;
            SET @V_VRMOVPESCONS = @C_VRMOVPESCONS;

            IF @C_IDTIPMOCVLI = 'D' BEGIN
               SET @V_VRMOVCLI     = (-1) * @C_VRMOVCLI;
               SET @V_VRMOVPESCONS = (-1) * @C_VRMOVPESCONS;
            END ELSE IF @C_IDTIPMOCVLI = 'X' BEGIN
               SET @V_VRMOVCLI     = 0;
               SET @V_VRMOVPESCONS = 0;
            END;

            /*Retorna o saldo imediatamente anterior*/
            SELECT
               @V_VRATUALIZACAO = (ISNULL(MAX(VRSALDOCONS),0)  + @V_VRMOVCLI),
               @V_VRATUALPECONS = (ISNULL(MAX(VRSALDPECONS),0) + @V_VRMOVPESCONS)
            FROM
               MOVICLIE
            WHERE
               (CDCLIENTE       = @P_CDCLIENTE      ) AND
               ((CDCONSUMIDOR   = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
                (@V_UCONSUMIDOR = 'U'))) AND
               (DTMOVCLI     = (SELECT
                                  MAX(DTMOVCLI)
                                FROM
                                   MOVICLIE
                                WHERE
                                   (CDCLIENTE     = @P_CDCLIENTE      ) AND
                                   ((CDCONSUMIDOR = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
                                    (@V_UCONSUMIDOR = 'U'))) AND
                                   (DTMOVCLI      < @C_DTMOVCLI        )
                               )
               );

            IF @C_IDTIPMOCVLI = 'A' BEGIN
               SET @V_VRATUALIZACAO = 0;
            END;

            /*Atualiza os lanamentos*/
            UPDATE
               MOVICLIE
            SET
               VRSALDOCONS  = @V_VRATUALIZACAO,
               VRSALDPECONS = @V_VRATUALPECONS,
               CDOPERECSALD = @P_OPERADOR,
               DTRECMOVCLIE = GETDATE()
            WHERE
               (CDCLIENTE      = @P_CDCLIENTE      ) AND
               ((CDCONSUMIDOR  = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
                (@V_UCONSUMIDOR = 'U'))) AND
               (DTMOVCLI       = @C_DTMOVCLI);

            FETCH NEXT FROM CUR_MOVICLIE INTO @C_DTMOVCLI,@C_VRMOVCLI,@C_VRMOVPESCONS,@C_IDTIPMOCVLI,@C_VRSALDOCONS,@C_VRSALDPECONS;
            
         END;
         CLOSE CUR_MOVICLIE;
         DEALLOCATE CUR_MOVICLIE;
      END;
   END;
   IF @V_REGMENORIGUAL > 1 BEGIN
      /*Seleciona os lanamentos a partir do atual.*/
      DECLARE CUR_MOVICLIE CURSOR FOR
         SELECT
            DTMOVCLI,VRMOVCLI,VRMOVPESCONS,IDTIPMOCVLI,VRSALDOCONS,VRSALDPECONS
         FROM
            MOVICLIE
         WHERE
            (CDCLIENTE     = @P_CDCLIENTE      ) AND
            ((CDCONSUMIDOR = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
             (@V_UCONSUMIDOR = 'U'))) AND
            (DTMOVCLI     >= @V_DTLANCAMENTO   )
         ORDER BY
            DTMOVCLI
      OPEN CUR_MOVICLIE;

      FETCH NEXT FROM CUR_MOVICLIE INTO @C_DTMOVCLI,@C_VRMOVCLI,@C_VRMOVPESCONS,@C_IDTIPMOCVLI,@C_VRSALDOCONS,@C_VRSALDPECONS;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         /*qrySaldoAnte*/
         SET @V_VRMOVCLI = @C_VRMOVCLI;
         SET @V_VRMOVPESCONS = @C_VRMOVPESCONS;

         IF @C_IDTIPMOCVLI = 'D' BEGIN
            SET @V_VRMOVCLI     = (-1) * @C_VRMOVCLI;
            SET @V_VRMOVPESCONS = (-1) * @C_VRMOVPESCONS;
         END ELSE IF @C_IDTIPMOCVLI = 'X' BEGIN
            SET @V_VRMOVCLI     = 0;
            SET @V_VRMOVPESCONS = 0;
         END;

         SELECT
            @V_VRATUALIZACAO = (ISNULL(VRSALDOCONS,0)  + @V_VRMOVCLI),
            @V_VRATUALPECONS = (ISNULL(VRSALDPECONS,0) + @V_VRMOVPESCONS)
         FROM
            MOVICLIE
         WHERE
            (CDCLIENTE      = @P_CDCLIENTE      ) AND
            ((CDCONSUMIDOR  = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
             (@V_UCONSUMIDOR = 'U'))) AND
            (DTMOVCLI      = (SELECT
                                 MAX(DTMOVCLI)
                              FROM
                                 MOVICLIE
                              WHERE
                                 (CDCLIENTE     = @P_CDCLIENTE      ) AND
                                 ((CDCONSUMIDOR = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
                                  (@V_UCONSUMIDOR = 'U'))) AND
                                 (DTMOVCLI       < @C_DTMOVCLI       )
                             )
            );

         IF @C_IDTIPMOCVLI = 'A' BEGIN
            SET @V_VRATUALIZACAO = 0;
         END;

         /*qryAtualiza*/
         UPDATE
            MOVICLIE
         SET
            VRSALDOCONS  = @V_VRATUALIZACAO,
            VRSALDPECONS = @V_VRATUALPECONS,
            CDOPERECSALD = @P_OPERADOR,
            DTRECMOVCLIE = GETDATE()
         WHERE
            (CDCLIENTE      = @P_CDCLIENTE   ) AND
            ((CDCONSUMIDOR  = @P_CDCONSUMIDOR) OR ((CDCONSUMIDOR IS NULL) AND
             (@V_UCONSUMIDOR = 'U'))) AND
            (DTMOVCLI       = @C_DTMOVCLI);

         FETCH NEXT FROM CUR_MOVICLIE INTO @C_DTMOVCLI,@C_VRMOVCLI,@C_VRMOVPESCONS,@C_IDTIPMOCVLI,@C_VRSALDOCONS,@C_VRSALDPECONS;

      END;
      CLOSE CUR_MOVICLIE;
      DEALLOCATE CUR_MOVICLIE;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_SALDO_CONS','4.11.212';
GO

